function cre=bp(F,K,DD,x,L,maxiter,le,epsi)

% basis pursuit - error eval.

lambda=exp(le);
lgains=SolveBP(DD,x,L,maxiter,lambda,epsi);
indices = zeros(K,1);
kk=0;
for i=1:L
    if abs(lgains(i)) > 10^(-6)
        kk=kk+1;
        %             indices(kk)=i;
    end
end

[lgai,indii]=sort(abs(lgains),'descend');
k=min(kk,K);
lgainss=zeros(size(lgains));
for i=1:k
    indices(i)=indii(i);
    lgainss(indii(i))=lgains(indii(i));
end


%figure(7); hold off
%plot(lgains),hold on
%plot(lgainss,'r')
%pause

A = F(:,indices(1:k)');
gains = inv(A'*A)*A'*x;
x_hat = F(:,indices(1:k)')*gains;

cre = (x - x_hat)'*(x - x_hat);